# std::is_literal_type

From cppreference.com
< cpp‎ | types

Defined in header `<type_traits>` |  |
template< class T > struct is_literal_type; |  | (since C++11) (deprecated in C++17)

If `T` satisfies all requirements of `LiteralType`, provides the member constant `value` equal true. For any other type, `value` is false.

The behavior is undefined if std::remove_all_extents_t<T> is an incomplete type and not (possibly cv-qualified) void.

### Template parameters

T | - | a type to check

### Helper variable template

template< class T > inline constexpr bool is_literal_type_v = is_literal_type<T>::value; |  | (since C++17) (deprecated)

## Inherited from std::integral_constant

### Member constants

value [static] | true if `T` is a literal type, false otherwise (public static member constant)

### Member functions

operator bool | converts the object to bool, returns `value` (public member function)
operator() (C++14) | returns `value` (public member function)

### Member types

Type | Definition
`value_type` | `bool`
`type` | std::integral_constant<bool, value>

### Notes

Only literal types may be used as parameters to or returned from constexpr functions. Only literal classes may have constexpr member functions.

### Example

Run this code

    #include <iostream>
    #include <type_traits>

    struct A {
        int m;
    };

    struct B {
        virtual ~B();
    };

    int main()
    {
        std::cout << std::boolalpha;
        std::cout << std::is_literal_type<A>::value << '\n';
        std::cout << std::is_literal_type<B>::value << '\n';
    }

Output:

    true
    false

### See also

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/types/is_literal_type&oldid=90998"